(defun salay  (lays / Layer)
  (setq #STAN_LAY '())
  (foreach &  lays
    (if (tblsearch "LAYER" &)
      (progn (setq Layer     (vlax->Layer &)
                   #STAN_LAY (append #STAN_LAY (list (list (vla-get-Name Layer) (vla-get-LayerOn Layer)))))
             (vla-put-LayerOn Layer :vlax-false)))))

(defun lolay (/ Layer)
  (repeat (length #STAN_LAY)
    (setq Layer (vlax->Layer (caar #STAN_LAY)))
    (vla-put-LayerOn Layer (cadr (car #STAN_LAY)))
    (setq #STAN_LAY (cdr #STAN_LAY))))

(defun _punkyWewnatrz  (lsalay / pa ssBl plin)
  (if (setq ssBl (ssget "X" (list (cons 0 #cINSERT))))
    (progn (setq ssBl (ssadd->list ssBl))
           (foreach &  ssBl
             (if (and (/= (casc 8 (entget &)) "0") (null (member (casc 8 (entget &)) lsalay)))
               (setq lsalay (append lsalay (list (casc 8 (entget &)))))))
           (salay lsalay)))
  (initget "Obiekt")
  (setq plin nil
        pa   (getpoint "\nWska punkt wewntrz obszaru albo [Obiekt]: "))
  (if (= pa "Obiekt")
    (if (setq plin (entsel #WskZamPoly))
      (progn (setq plin (car plin))
             (if (or (not (in (casc 0 (entget plin)) (list #cPOLYLINE #cLWPOLYLINE)))
                     (not (checkClosedPolyline plin)))
               (setq plin nil)))))
  (if (and pa (null plin))
    (if (and (setq plin (br_bpoly pa)) (entget plin) (= (casc 0 (entget plin)) #cPOLYLINE))
      (progn (vlax->PutProperty
               (vlax-ename->vla-object plin)
               (list (list 'Color (GetKolorWyroznienia1)) (list 'lineweight #markLineweight)))
             (arxDraworder plin #ToFront)
             (redraw plin)
             (if (not (dialog->yes_no "Akceptacja ?"))
               (progn (WymazElementy plin) (setq plin nil))))
      (progn (prompt "\nNie odnaleziono obszaru zamknitego.") (setq plin nil))))
  (lolay)
  plin)

(defun point->createObject  (lsalay currlay fnOp / pline)
  (if (start_tryb T0)
    (progn (if (setq pline (_punkyWewnatrz lsalay))
             (progn (vlax->PutProperty                      
                      (vlax-ename->vla-object pline)
                      (list (list 'Color acByLayer)
                            (list 'ConstantWidth 0.0)
                            (list 'Layer currlay)
                            (list 'Lineweight acLnWtByLayer)))
                    (if fnOp
                      (apply fnOp (list pline)))))
           (lovar))))


(defun _getZ  (prom / pr p e z za pk ss w len l)
  (setq p "")
  (while (and p (= (type p) 'STR))
    (setq pr (strcat "\n"
                     (if _wskZet
                       "Punkt"
                       "Wysoko")
                     "/["
                     prom
                     " "

                     
                     (if _wskZet
                       "wysokoci"
                       "punktu")
                     "]: "))
    (initget (if _wskZet
               "Punkt"
               "Wysoko"))
    (if _wskZet
      (setq p (entsel pr))
      (setq p (getpoint pr)))
    (setq _wskZet (or (= p "Wysoko") (and _wskZet (/= p "Punkt")))))
  (cond ((and _wskZet
              p
              (listp p)
              (= (casc 0 (setq e (entget (setq p (car p))))) #cINSERT)
              (in (casc 2 e) '("OTRN" "OTRS")))
         (setq w (casc 10 e)))
        ((and p
              (listp p)
              (setq ss (GetCEn p
                               0.5
                               (list (cons 0 #cINSERT) '(2 . "OTR?,PIK_??"))
                               nil))
              (> (setq len (sslength ss)) 0))
         (setq za nil
               l  0)
         (while (and (null za) (< l len))
           (setq z  (ssname ss l)
                 l  (1+ l)
                 za (equal (_2D p) (_2D (casc 10 (entget z))))))
         (if za
           (setq p z
                 w (casc 10 (entget p)))))
        (T
         (setq w  nil
               pk nil)))
  (if w
    (progn (setq z  (caddr w)
                 za (atof (casc 1 (entget (entnext p)))))
           (if (and (= (substr (casc 2 (entget p)) 1 4) "OTRN") (not (equal z za 0.1)))
             (setq z za))
           (setq pk (list (car w) (cadr w) z))
           (princ z)))
  pk)

